var loadedThemes = [];
var toastContainer;
var toastAddCard;
var styleSelection = "default";
customToastConfigTab = function() {
    loadedThemes = [];
    toastContainer = $('<div class="fs-toast-container"/>');
    toastAddCard = $('<div class="fs-toast-card-add"/>')
        .hover(function(){
            $(this).addClass('fs-toast-card-add-hover');
        }, function(){
            $(this).removeClass('fs-toast-card-add-hover');
        })
        .appendTo(toastContainer);
    new FR.MultiFileEditor({
        renderEl: toastAddCard,
        maxlength: 1,
        accept: '.zip',
        width: 240,
        height: 120,
        hideFileList: true,
        showViewImage: false,
        listeners: [{
            eventName: "afteredit",
            action: function () {
                var customStyle = {
                    id: this.getValue()[0].attach_id,
                    type: "toast"
                };
                $('td', this.element).remove();
                var config = {
                	url: FR.servletURL + "?op=customstyle&cmd=save_style",
                	data: customStyle
                };
                var completeFn = function(res, status){
                    if (status == 'success') {
                        var toastStyle = FR.jsonDecode(res.responseText);
                        if ($.isEmptyObject(toastStyle) === false) {
                            addCustomStyleCard(toastStyle);
                        } else {
                            showRestartDialog(FR.i18nText("FS-CustomStyle_Toast_Error"), FR.i18nText("FS-CustomStyle_Toast_Res_Empty_alert"));
                        }
                    }
            	};
            	FS.Async.ajax(config,completeFn);
            }
        }]
    });
    $('img', toastAddCard).remove();
    $('input', toastAddCard).attr('accept','application/zip').css({
        'height': '100%',
        'width': '100%'
    });
    $('<div class="add-toast-text"/>').text(FR.i18nText("FS-CustomStyle_Toast_Add"))
        .appendTo(toastAddCard);
    return {
        title: FR.i18nText("FS-CustomStyle_Toast_Tab"),
        content: toastContainer
    }
};

addCustomStyleCard = function (style) {
    var cover;
    if ($.inArray(style.name, loadedThemes) > -1) {
        showRestartDialog(FR.i18nText("FS-CustomStyle_Toast_Error"), FR.i18nText("FS-CustomStyle_Toast_Exist_alert"));
        return;
    }
    var $card = $('<div class="fs-toast-card"/>')
        .hover(function(){
            $(this).addClass('hover');
        }, function(){
            $(this).removeClass('hover');
        }).click(function(){
            var config = {
                url: FR.servletURL + "?op=customstyle&cmd=set_style",
                data: {
                    type: "toast",
                    name: style.name
                }
            };
            var completeFn = function(res, status){
                var result = FR.jsonDecode(res.responseText);
                $('.fs-toast-select', toastContainer).hide();
                $mask.show();
                getStyleSelection();
                if (result.success) {
                    showRestartDialog(FR.i18nText("FS-CustomStyle_Toast_Prompt"), FR.i18nText("FS-CustomStyle_Toast_Restart"));
                }
                else{
                    showRestartDialog(FR.i18nText("FS-CustomStyle_Toast_Error"), FR.i18nText("FS-CustomStyle_Toast_SetStyle_Failed"));
                }
            };
            FS.Async.ajax(config,completeFn);
            $('.fs-toast-select', toastContainer).hide();
            $mask.show();
        });
    if (style.cover) {
        cover = style.cover;
    }else{
        cover = '/com/fr/plugin/resource/default@2x.png';
    }
    $('<img class="fs-toast-cover"/>').attr("src", FR.servletURL + '?op=resource&resource=' + cover).appendTo($card);
    var $mask = $('<div class="fs-toast-select"/>').appendTo($card);
    $('<div class="fs-toast-title"/>').attr("title", style.name)
        .text(style.name).appendTo($card);
    if(styleSelection !== style.name){
        $mask.hide();
    }
    $card.insertBefore(toastAddCard);
    loadedThemes.push(style.name);
};

popCustomToastData = function (tabPane) {
    getStyleSelection();
    var defaultStyles = [
        {
            name: 'Default',
            cover: '/com/fr/plugin/customstyle/resource/default@2x.png'
        }
    ];
    $.each(defaultStyles, function(index, style){
        addCustomStyleCard(style);
    });
    var config = {
    	url: FR.servletURL + "?op=customstyle&cmd=get_list",
        data: {
            type: "toast"
        }
    };
    var completeFn = function(res, status){
    	var list = FR.jsonDecode(res.responseText);
    	$.each(list, function(index, style){
    		addCustomStyleCard(style);
    	});
    };
    FS.Async.ajax(config,completeFn);
};

getStyleSelection = function(){
    var result = FS.Sync.ajax({
        url: FR.servletURL + '?op=customstyle&cmd=get_selection',
        type: 'POST',
        data: {
            type: 'toast'
        }
    });
    styleSelection = result.toast;
    if(!styleSelection){
        styleSelection = "default";
    }
};

showRestartDialog = function (title, content2show) {
    var content;
    if (typeof content2show === 'string') {
        content = content2show;
    }
    var dlg = new FR.Dialog({
        title : title,
        height : 155,
        width: 320,
        widgetName: 'customdialog',
        contentWidget: {
            type: 'absolute',
            items: [
                {
                    el: $('<div>'+content+'</div>').css({
                        'width': '100%',
                        'top': 35,
                        'font-size': '14px',
                        'text-align': 'center',
                        'position': 'absolute'
                    })
                },
                {
                    type: 'quickbutton',
                    text: FR.i18nText("FS-CutomStyle_Toast_OK"),
                    width: 60,
                    height: 30,
                    x: 130,
                    y: 75,
                    handler : function () {
                        dlg.getWidgetByName('customdialog').doClose();
                    }
                }
            ]
        }
    });
    dlg.setVisible(true);
};

FS.Plugin.LookAndFeelSettings.push({
    item: customToastConfigTab,
    action: popCustomToastData
});